This section will show you how to deploy your project on different environments.

## Setup

First of all you'll need to install [MobaXterm](https://mobaxterm.mobatek.net/download.html) in order to connect to the server.
Then, if your're on Linux you can skip the following section, otherwise if you are on Windows you'll have to install Windows Subsystem for Linux (WSL) since the deployment of the app is not working with windows commands.

## Configuration of MobaXterm

First open a new session and connect to the distant host. Don't forget to add the path to the private key in the advanced SSH settings. Also don't forget to ask an administrator to add your public key so you can access the server.

## Deploy Ecolyo

### Deploy version to builds branches

3 builds branch are today available for Ecolyo:

- build: reflect the build of the master branch and the version deployed in production environment
- build-dev: reflect the build of the dev branch and the version deployed on dev environment
- build-test reflect a temporary build which can be used for test purpose

#### Windows

If you use windows, make sure you have WSL installed and a Linux distribution. For more information about it see the [Install WSL section](../getting_started/setup_your_environment.md)

First open your Ubuntu terminal (or any other distribution you've installed), and clone the project in the repertory of your choice. Once you've selected the branch of you want to deploy, write the following command :

```
yarn
yarn build
```

After this, you can launch the deployment using the command linked to the target branch.
```
# deploy on build-test branch
yarn deploy-test
# deploy on build-dev branch
yarn deploy-dev
# deploy on build branch
yarn deploy
```

#### Linux

From your current branch, run `yarn build`.
After this, you can launch the deployment using the command linked to the target branch.
```
# deploy on build-test branch
yarn deploy-test
# deploy on build-dev branch
yarn deploy-dev
# deploy on build branch
yarn deploy
```

### Deploy build-dev branch to Scaleway

You can now deploy the content of build-dev branch into Scaleway using the scripts present on the Scaleway server.
For more informations you can check for [Easy Cozy scripts](../../../easycozy/scripts/).

### Deploy build branch to Cozy

Use thecozy-app-publish command after replacing following value:

- $REGISTRY_TOKEN : token provided by Cozy team
- $VERSION_NUMBER: version of the application
- $COZY_SPACE: space of the Cozy 

```
yarn cozy-app-publish --token $REGISTRY_TOKEN --build-url https://forge.grandlyon.com/web-et-numerique/llle_project/ecolyo/-/archive/build/ecolyo-build.tar.gz --manual-version $VERSION_NUMBER --space $COZY_SPACE
```

More information at [cozy-app-publish/](https://docs.cozy.io/en/cozy-app-publish/)